'''
Created on 14.10.2011

@author: ays
'''

from artixds.conditionfunctionplugins.conditionplugin import add_plugin
from artixds.generalfunction.conditionhelper import __timeIn, __dateIn, __dayIn, __getAsList, __hasOptions
from datetime import date,datetime

def hasClient(self):
    return self.card and self.card["card"] and self.card["card"]["client"]

@add_plugin
def hasClientOptions(self, options = None):
    if not hasClient(self):
        return False
    return __hasOptions(options, self.card["card"]["client"]["extendedoptions"])

@add_plugin
def birthdayDate(self, firstDay = None, lastDay = None):
    return self.specialDate(firstDay, lastDay, "birthday")

@add_plugin
def birthdayIn(self, beginTime = None, endTime = None):
    return self.birthdayDate(beginTime, endTime)

@add_plugin
def birthdayDateIn(self, beginDate = None, endDate = None):
    return self.specialDateIn(beginDate, endDate, "birthday")

@add_plugin
def specialDate(self, firstDay = None, lastDay = None, datename = 'specialdate1'):

    if not hasClient(self):
        return False

    testDate = self.card["card"]["client"][datename]
    if not testDate.isValid():
        return False

    return __dayIn(self.check["datetimebeg"].date(), testDate, firstDay, lastDay)

@add_plugin
def specialdayIn(self, beginTime = None, endTime = None, datename = 'specialdate1'):
    return self.specialDate(beginTime, endTime, datename)

@add_plugin
def specialDateIn(self, beginDate = None, endDate = None, dateName = 'specialdate1'):

    if not hasClient(self):
        return False

    if dateName not in self.card["card"]["client"]:
        return False

    _testDate = self.card["card"]["client"][dateName]
    if not _testDate.isValid():
        return False

    testDate1 = testDate2 = self.check["datetimebeg"].date()

    if beginDate:
        testDate1 = date(datetime.strptime(beginDate, '%Y-%m-%d').year, _testDate.month(), _testDate.day())

    if endDate:
        testDate2 = date(datetime.strptime(endDate, '%Y-%m-%d').year, _testDate.month(), _testDate.day())

    return __dateIn(testDate1, beginDate, endDate) or __dateIn(testDate2, beginDate, endDate)

@add_plugin
def isVerificated(self):
    return self.card and not(self.card["verificationtype"] is None)

@add_plugin
def hasVerificationTypes(self, types=list()):
    typeNames = [method["typename"] for method in self.card["card"]["sourcecardgroup"]["verificationmethods"]]

    if not typeNames:
        return False

    for typeName in types:
        if typeName not in typeNames:
            return False

    return True
