# -*- coding: utf-8 -*-

from functools import reduce
from artixds.generalfunction.conditionhelper import __inventInCheckByGroup, __hasGroups

def inventCountInCheckByGroup(self, group, withPartOfKit = True):
    sel = __inventInCheckByGroup(self.checkWrapper, group, withPartOfKit)
    return len(sel)

def inventQuantInCheckByGroup(self, group, withPartOfKit = True):
    sel = __inventInCheckByGroup(self.checkWrapper, group, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x["cquant"],sel)) if sel else 0

def inventSumInCheckByGroup(self, groups, withPartOfKit = True):
    sel = __inventInCheckByGroup(self.checkWrapper, groups, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x['sumb'], sel)) if sel else 0

def cheapestGoodsByGroups(self, divider, groups, percent):
    '''
    Скидка на 'N' самых дешевых товаров в чеке из указанных групп,
    где 'N' - это количество товаров в чеке из указанных групп деленное на 'divider'.
    divider - кратность
    groups - список групп товаров
    percent - скидка на позицию

    return словарь из номеров позиций и сумм скидок.
    '''

    if divider < 1:
        return {}

    extCheck = []
    
    for item in self.checkWrapper.getGoodsList():
        if __hasGroups(groups, item.data["tmc"]["tmcgroups"]):
            quantItem = 1 if item.data['tmcunit']['fractional'] else int(item.data['bquant'])
            for pos in range(quantItem):
                extCheck.append((item.data['posnum'], item.data['price'] * percent / 100.0))

    extCheck = sorted(extCheck, key=lambda k: k[1])
    extCheck = extCheck[:len(extCheck)//divider]

    result = {}
    for posn in extCheck:
        if not posn[0] in result:
            result[posn[0]] = 0
        result[posn[0]] = result[posn[0]] + posn[1]

    return result
