'''
Created on 14.10.2011

@author: ays
'''
import time
from datetime import date, datetime, timedelta
from functools import reduce
import re

import logging

log = logging.getLogger("_Tets_")

re_type = type(re.compile('.'))

def isIntercalaryYear(year):
    if year % 4 != 0 or (year % 100 == 0 and year % 400 != 0):
        return False
    return True

def __timeIn(currentTime = None, beginTime = None, endTime = None):
    if not currentTime:
        return True    
    if not beginTime and not endTime:
        return True    
    _currentTime = time.strptime(currentTime.toString('HH:mm'), '%H:%M')
    if beginTime and _currentTime < time.strptime(beginTime, '%H:%M'):
        return False
    if endTime and _currentTime > time.strptime(endTime, '%H:%M'):
        return False
    return True

def __dateIn(currentDate, beginDate, endDate):
    if not currentDate:
        return True    
    if not beginDate and not endDate:
        return True    
    _currentDate = date(currentDate.year(), currentDate.month(), currentDate.day()) if type(currentDate) != date else currentDate
    if beginDate and _currentDate < datetime.strptime(beginDate, '%Y-%m-%d').date():
        return False
    if endDate and _currentDate > datetime.strptime(endDate, '%Y-%m-%d').date():
        return False
    return True

def __dateTimeIn(currentDateTime, beginDateTime, endDateTime):
    if not currentDateTime or not (beginDateTime or endDateTime):
        return True    
    if beginDateTime and currentDateTime < beginDateTime:
        return False
    if endDateTime and currentDateTime > endDateTime:
        return False
    return True

def __dayIn(currentDate, specialDate, daysBefore, daysAfter):
    _currentDate = date(currentDate.year(), currentDate.month(), currentDate.day())
    startDate = _currentDate - timedelta(days=daysAfter)
    endDate = _currentDate + timedelta(days=daysBefore)
    specialStartDay = specialEndDay = specialDate.day()
    if specialDate.day() == 29 and specialDate.month() == 2:
        if not isIntercalaryYear(startDate.year):
            specialStartDay = 28
        if not isIntercalaryYear(endDate.year):
            specialEndDay = 28
    try:
        return (startDate <= date(startDate.year, specialDate.month(), specialStartDay) <= endDate or
            startDate <= date(endDate.year, specialDate.month(), specialEndDay) <= endDate)
    except ValueError:
        return False

def __getAsList(value):
    return value if type(value) == list else [value]


def __hasOptions(options, data, withAll=False):
    _options = __getAsList(options)
    if data is None:
        return False
    _data = data.split(',')
    for op in _options:
        result = False
        for dat in _data:
            if re_type == type(op):
                if re.search(op, dat):
                    result = True
            else:
               if dat == op:
                    result = True
        if not withAll and result:
            return True
        if not result and withAll:
            return False
    return False if not withAll else True	

def __hasCatalogs(catalog, data, withAll=False):
    _data = set ( map(lambda x: x["catalogid"], data) )
    _catalog = set ( catalog )
    if not withAll:
        return True if _catalog & _data else False
    else:
        return True if not _catalog - _data else False

def __hasGroups(groups, data): 
    _groups = set(groups) 
    _data   = set( map(lambda y: y["code"], data) )
    return True if _groups & _data else False

def __inventInCheck(checkWrapper, param, value):
    return list(filter(lambda goodsitem: goodsitem.data[param] in __getAsList(value), checkWrapper.getGoodsList()))

def __aggregateInventInCheck(checkWrapper, aggregateParam, value, param):
    sel = __inventInCheck(checkWrapper, param, value)
    return reduce(lambda  x, y: x + y, map(lambda x: x.data[aggregateParam], sel)) if sel else 0



def __isPartOfDisKit(object):
    return "partOfKit" in object and object["partOfKit"] == True

def __inventInCheckByOption(checkWrapper, options, WithPartOfKit=True):
    sel = [item.data for item in checkWrapper.getGoodsList() if not __isPartOfDisKit(item.data) or WithPartOfKit]
    return list(filter(lambda goodsitem: __hasOptions(options, goodsitem["extendetoptions"]), sel))

def __inventInCheckWithAllOptions(checkWrapper, options, WithPartOfKit=True):
    sel = [item.data for item in checkWrapper.getGoodsList() if not __isPartOfDisKit(item.data) or WithPartOfKit]
    return list(filter(lambda goodsitem: __hasOptions(options, goodsitem["extendetoptions"], True), sel))

def __inventInCheckByCatalog(checkWrapper, catalog, WithPartOfKit=True):
    sel = [item.data for item in checkWrapper.getGoodsList() if not __isPartOfDisKit(item.data) or WithPartOfKit]
    return list(filter(lambda goodsitem: __hasCatalogs(catalog, goodsitem["tmc"]["catalogs"]), sel))

def __inventInCheckWithAllCatalogs(checkWrapper, catalog, WithPartOfKit=True):
    sel = [item.data for item in checkWrapper.getGoodsList() if not __isPartOfDisKit(item.data) or WithPartOfKit]
    return list(filter(lambda goodsitem: __hasCatalogs(catalog, goodsitem["tmc"]["catalogs"], True), sel))

def __inventInCheckByGroup(checkWrapper, groups, WithPartOfKit=True):
    sel = [item.data for item in checkWrapper.getGoodsList() if not __isPartOfDisKit(item.data) or WithPartOfKit]
    return list(filter(lambda goodsitem: __hasGroups(groups, goodsitem["tmc"]["tmcgroups"]), sel))
    
