# -*- coding: utf-8 -*-

def limitCount(self, maxCount, index):
    '''
    Функция подсчитывает скидку для каждого товара
    Скидка будет даваться только на maxCount каждого вида товара
    по новой индексной цене с индексом равным index
    maxCount - максимальное количество товара
    index - индекс дополнительной цены
    Возвращает словарь {позиция:размер скидки}
    '''
    positions = {}
    totals = {}
    indexPrice = str(index)
    for item in self.checkWrapper.getGoodsList():
        if self.checkWrapper.isPartOfKit(item.data['posnum']):
            continue
        if indexPrice not in item.data['tmc']['indexprices']:
            continue
        bcode = item.data['bcode']
        if bcode not in totals:
            totals[bcode] = 0
        if totals[bcode] < maxCount:
            count = min(item.data['bquant'], maxCount - totals[bcode])
            discount = round(item.data['price'] * count, 2) - round(item.data['tmc']['indexprices'][indexPrice]['price'] * count, 2)
            totals[bcode] += count
            positions[item.data['posnum']] = discount
    return positions
