# -*- coding: utf-8 -*-
'''
Created on 21 апр. 2017 г.
@author: lay
'''

def progressiveDiscount(self, minDiscount, maxDiscount, discountStep, catalogs):
    '''
    Скидка на самые дешевые товары от minDiscount до maxDiscount с шагом discountStep,
    при условии, что товар отмечен в одном из Каталогов catalogs.
    Возвращает словарь {позиция:размер скидки}
    '''
    #количество скидочных позиций
    stepsCount = ((maxDiscount - minDiscount) / discountStep) + 1
    # Отсортированный развернутый список номеров позиций чека по возрастанию цены
    extCheck = []
    #результирующий список inpact-позиций
    result = {}

    #оставляем товары, которые есть в каталоге
    for item in self.checkWrapper.getGoodsList():
        for catalog in item.data["tmc"]["catalogs"]:
            if catalog["catalogid"] in catalogs:
                result[int(item.data["posnum"])] = 0
                break

    for item in self.check['goodsitems']:
        quantItem = 1 if item['tmcunit']['fractional'] else int(item['bquant'])
        for pos in range(quantItem):
            if item['posnum'] in result:
                extCheck.append((item['posnum'], item['price'], item['bquant']))

    extCheck = sorted(extCheck, key=lambda k: k[1])

    pos = 0
    #если позиций меньше, чем скидок, сразу применяем минимальную скидку к наибольшей позиции
    if len(extCheck) < stepsCount:
        extCheck.reverse()
        for posn in extCheck:
            if posn[0] in result:
                result[posn[0]] = result[posn[0]] + (posn[1] * (minDiscount + discountStep * pos)) / 100
                pos = pos + 1
            if pos == len(extCheck):
                break
    else:
        for posn in extCheck:
            if posn[0] in result:
                result[posn[0]] = result[posn[0]] + (posn[1] * (maxDiscount - discountStep * pos)) / 100
                pos = pos + 1
            if pos == stepsCount:
                break

    return result
