# -*- coding: utf-8 -*-

class KlPositionPart(object):
    '''
    Часть позиции
    '''
    def __init__(self, parent):
        self.parent = parent

        # Эти поля называются как в позиции, это сделано специально
        self.bquant = 0
        self.posnum = None
        self.sumn = None
        self.sumb = None
        self.partOfKit = False

    def getCode(self):
        return self.parent.pos.data['code']

    def isUniteAvailable(self):
        return self.parent.isUniteAvailable()

    def setQuantity(self, bquant):
        '''
        Изменение количества с пересчетом сумм
        '''
        self.parent.setQuantityForObject(self, bquant)

    def isWholePos(self):
        '''
        Часть позиции занимает все количество
        '''
        return abs(round(self.parent.bquant - self.bquant, 3)) < 0.001

    def uniteWith(self, pos):
        '''
        Объединение позиции pos с этой
        pos - позиция или часть позиции которая добавляется к текущей
        '''
        self.setQuantity(self.bquant + pos.bquant)
        self.parent.uniteWith(pos)

    def source(self):
        '''
        Возвращает исходную позицию
        '''
        return self.parent

    def uniqueKey(self):
        '''
        Уникальный ключ позиции
        используется для объединения позиций
        '''
        return self.parent.uniqueKey()

    def hasUnited(self):
        '''
        ВозвращаетTrue если была объединена с другими позициями
        '''
        return self.parent.hasUnited()

    def __repr__(self):
        return "KlPositionPart(code=%s,bquant=%s,posnum=%s,parentpos=%s)" % (repr(self.parent.pos.data['code']), self.bquant, self.posnum, self.parent.posnum)
