# -*- coding: utf-8 -*-

from config import Config
from sqlalchemy import Table, Column, Integer, String, MetaData, Text, TIMESTAMP 


metaData = MetaData()
discountSystemTable = Table("discountsystem", metaData,
Column('id' if Config().getBool("MysqlServer", "serverDb", False) else "discountSystemId", Integer, primary_key=True),
Column('discsystem', Text),
Column('bonusearnsystem', Text),
Column('bonuslimitsystem', Text),
Column('update_time', TIMESTAMP),
Column('seconddiscsystem', Text))


class DiscountSystemData(object):
    """
    Discount system (representation in Database)
    
    """
    def __init__(self, name=None, system=None):
        """
        name - name
        system - root campaign group object in JSON format 
        """
        self.name = name
        self.discsystem = system
