class ExtendedOption(object):
    
    def __init__(self, option):
        self.option = option
        
    def __eq__(self, other):
        return self.option == other.option
    
    def __hash__(self):
        return hash(self.option)
    
    def like(self, likeExpr):
        return self.option.startswith(likeExpr)

    def getValue(self, name):
        t = self.option.split('=')
        return t[1] if len(t) > 1 else None

class ExtendedOptions(object):
    
    def __init__(self, options=None):
        if options:
            self.options = [ ExtendedOption(option.strip()) for option in options.split(u',') ]
        else:
            self.options = []
    
    def __in__(self, option):
        return option in self.options
    
    def hasOptionLike(self, likeExpr):
        for option in self.options:
            if option.like(likeExpr):
                return True
        return False
    
    def valueOf(self, optionName):
        for option in self.options:
            if option.like(optionName):
                return option.getValue(optionName)
        return None