# -*- coding: utf-8 -*-
'''
Created on 15.03.2011

@author: gsu
'''

from artixds.ratefunctionplugins.rateplugin import add_plugin
from artixds.ratefunctionplugins.extendedoption import ExtendedOption, ExtendedOptions

def __calculateSumCheapest(checkWrapper, count, extops, rate = 100.0, countDisc = 1) :
    prices = []
    for item in checkWrapper.getGoodsList():
        extendedOptions = ExtendedOptions(item.data["extendetoptions"])
        for extop in extops:
            if extendedOptions.hasOptionLike(extop) and item.data["price"] > 0.001:
                prices.extend([ item.data["price"] ] * int(item.data["bquant"]))
                break
    prices.sort()
    return sum(prices[:(len(prices)//count)*countDisc]) * rate / 100.0
			
@add_plugin
def sumCheapestEx(self, count, extops, rate = 100.0, countDisc = 1):
    return __calculateSumCheapest(self.checkWrapper, count, extops, rate, countDisc)
	
@add_plugin
def sumCheapest(self, count, extops, rate = 100.0):
    return __calculateSumCheapest(self.checkWrapper, count, extops, rate)

''' 
@ brief Функция рассчитывает скидку для товаров, которые входят хоть в один из каталогов extops
@ param self - чек
@ param count - коэффициент количества товаров на которые даётся скидка
@ param extops - содержит список идентификаторов каталогов(числа)
@ param rate - процент скидки
@ param countDisc - количество вхождений скидки
@ return Сумма скидки
'''
def __calcSumCheapestFromCatalog(checkWrapper, count, extops, rate = 100.0, countDisc = 1):
    catalogs = set(extops)
    prices = []
    for item in checkWrapper.getGoodsList():
        itemCatalogs = set(int(catalog["catalogid"]) for catalog in item.data["tmc"]["catalogs"])
        if itemCatalogs & catalogs and item.data["price"] > 0.001:
            prices.extend([ item.data["price"] ] * int(item.data["bquant"]))
    prices.sort()
    return sum(prices[:(len(prices)//count)*countDisc]) * rate / 100.0

@add_plugin
def sumCheapestFromCatalogEx(self, count, extops, rate = 100.0, countDisc = 1):
    return __calcSumCheapestFromCatalog(self.checkWrapper, count, extops, rate, countDisc)

@add_plugin
def sumCheapestFromCatalog(self, count, extops, rate = 100.0):
    return __calcSumCheapestFromCatalog(self.checkWrapper, count, extops, rate)
