# -*- coding: utf-8 -*-

from artixds.ratefunctionplugins.rateplugin import add_plugin
import artixds.generalfunction.checkbyoptioncondition as module_options
import artixds.generalfunction.checkbycatalogcondition as module_catalogs
import artixds.generalfunction.checkbycodecondition as module_codes
import artixds.generalfunction.checkbygroupcondition as module_group
import artixds.generalfunction.incheckcondition as module_incheck
import artixds.generalfunction.everynextnumber as everynextnumber
import artixds.generalfunction.cheapgoods as cheapgoods
import artixds.generalfunction.expensivegoods as expensivegoods
import artixds.generalfunction.everynextnumberongoods as everynextnumberongoods
import artixds.generalfunction.limitcount as limitcount
import artixds.generalfunction.cataloggoods as cataloggoods
import artixds.generalfunction.progressivediscount as progressivediscount
import artixds.generalfunction.counters as counters
import artixds.generalfunction.personaldiscount as personaldiscount
import artixds.generalfunction.proportionaldiscount as proportionaldiscount
import artixds.generalfunction.card as card
import artixds.generalfunction.impact as impact

# invent...InCheckByOption
@add_plugin
def inventCountInCheckByOption(self, options, withPartOfKit = True):
    return module_options.inventCountInCheckByOption(self, options, withPartOfKit)

@add_plugin
def inventQuantInCheckByOption(self, options, withPartOfKit = True):
    return module_options.inventQuantInCheckByOption(self, options, withPartOfKit)

@add_plugin
def inventSumInCheckByOption(self, options, withPartOfKit = True):
    return module_options.inventSumInCheckByOption(self, options, withPartOfKit )

@add_plugin
def inventCountInCheckWithAllOptions(self, options, withPartOfKit = True):
    return module_options.inventCountInCheckWithAllOptions(self, options, withPartOfKit )

@add_plugin
def inventQuantInCheckWithAllOptions(self, options, withPartOfKit = True):
    return module_options.inventQuantInCheckWithAllOptions(self, options, withPartOfKit)

@add_plugin
def inventSumInCheckWithAllOptions(self, options, withPartOfKit = True):
    return module_options.inventSumInCheckWithAllOptions(self, options, withPartOfKit)


# invent...InCheckByCatalog
@add_plugin
def inventCountInCheckByCatalog(self, catalog, withPartOfKit = True):
    return module_catalogs.inventCountInCheckByCatalog(self, catalog, withPartOfKit)

@add_plugin
def inventQuantInCheckByCatalog(self, catalog, withPartOfKit = True):
    return module_catalogs.inventQuantInCheckByCatalog(self, catalog, withPartOfKit)

@add_plugin
def inventSumInCheckByCatalog(self, catalog, withPartOfKit = True):
    return module_catalogs.inventSumInCheckByCatalog(self, catalog, withPartOfKit)

@add_plugin
def inventCountInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
    return module_catalogs.inventCountInCheckWithAllCatalogs(self, catalogs, withPartOfKit)

@add_plugin
def inventQuantInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
    return module_catalogs.inventQuantInCheckWithAllCatalogs(self, catalogs, withPartOfKit)

@add_plugin
def inventSumInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
    return module_catalogs.inventSumInCheckWithAllCatalogs(self, catalogs, withPartOfKit)


# invent...InCheckBy.Code
@add_plugin
def inventSumInCheckByCode(self, code = None):
    return module_codes.inventSumInCheckByCode(self, code)

@add_plugin
def inventCountInCheckByCode(self, code = None):
    return module_codes.inventCountInCheckByCode(self, code)

@add_plugin
def inventQuantInCheckByCode(self, code = None):
    return module_codes.inventQuantInCheckByCode(self, code)

@add_plugin
def inventSumInCheckByBcode(self, bcode = None):
    return module_codes.inventSumInCheckByBcode(self, bcode)

@add_plugin
def inventCountInCheckByBcode(self, bcode = None):
    return module_codes.inventCountInCheckByBcode(self, bcode)

@add_plugin
def inventQuantInCheckByBcode(self, bcode = None):
    return module_codes.inventQuantInCheckByBcode(self, bcode)


# invent....InCheck
@add_plugin
def inventCountInCheck(self):
    return module_incheck.inventCountInCheck(self)

@add_plugin
def inventQuantInCheck(self, uniteFractional = True):
    return module_incheck.inventQuantInCheck(self, uniteFractional)

# invent...InCheckByGroup
@add_plugin
def inventCountInCheckByGroup(self, group, withPartOfKit = True):
    return module_group.inventCountInCheckByGroup(self, group, withPartOfKit)

@add_plugin
def inventQuantInCheckByGroup(self, group, withPartOfKit = True):
    return module_group.inventQuantInCheckByGroup(self, group, withPartOfKit)

@add_plugin
def inventSumInCheckByGroup(self, groups, withPartOfKit = True):
    return module_group.inventSumInCheckByGroup(self, groups, withPartOfKit)

@add_plugin
def progressiveDiscount(self, minDiscount, maxDiscount, discountStep, catalogs):
    return progressivediscount.progressiveDiscount(self, minDiscount, maxDiscount, discountStep, catalogs)

@add_plugin
def everyNextNumber(self, number, percent, desc = True):
    return everynextnumber.getImpact(self, number, percent, desc)

@add_plugin
def cheapestGoodsByGroups(self, divider, groups, percent):
    return module_group.cheapestGoodsByGroups(self, divider, groups, percent)

@add_plugin
def cheapGoodsWithOptions(self, count, extops, rate = 100.0, countDisc = 1, toCheapest = True):
    return cheapgoods.cheapGoodsWithOptions(self, count, extops, rate, countDisc, toCheapest)

@add_plugin
def cheapGoodsFromCatalog(self, count, extops, rate = 100.0, countDisc = 1, toCheapest = True):
    return cheapgoods.cheapGoodsFromCatalog(self, count, extops, rate, countDisc, toCheapest)

@add_plugin
def cheapGoods(self, count, rate = 100.0, countDisc = 1, toCheapest = True):
    return cheapgoods.cheapGoods(self, count, rate, countDisc, toCheapest)

@add_plugin
def cheapGoodsBySetWithConditions(self, rate, setSize, countDisc, conditions="True"):
    return cheapgoods.cheapGoodsBySetWithConditions(self, rate, setSize, countDisc, conditions)

@add_plugin
def expensiveGoods(self, countGoods, conditionSum, resultSum, ignorePosWithPriceEqualMin = True):
    return expensivegoods.expensiveGoods(self, countGoods, conditionSum, resultSum, ignorePosWithPriceEqualMin)

@add_plugin
def expensiveGoodsFromCatalogs(self, countGoods, conditionCatalogs, resultSum, ignorePosWithPriceEqualMin=True):
    return expensivegoods.expensiveGoodsFromCatalogs(self, countGoods, conditionCatalogs, resultSum,
                                                     ignorePosWithPriceEqualMin)

@add_plugin
def everyNextNumberOnGoods(self, number, deep, percent, extops):
    return everynextnumberongoods.everyNextNumberOnGoods(self, number, deep, percent, extops)

@add_plugin
def limitCount(self, maxCount, index):
    return limitcount.limitCount(self, maxCount, index)

@add_plugin
def catalogGoods(self, catalogid):
    return cataloggoods.catalogGoods(self, catalogid)

# counters
@add_plugin
def countersQuantByBcode(self, idCounter, bcode, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):
    return counters.countersQuantByBcode(self, idCounter, bcode, percent, limit, calcWhenLessLimit, alwaysCalcDiscount)

@add_plugin
def countersQuantByCode(self, idCounter, code, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):
    return counters.countersQuantByCode(self, idCounter, code, percent, limit, calcWhenLessLimit, alwaysCalcDiscount)

@add_plugin
def countersQuantByCatalog(self, idCounter, catalog, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):
    return counters.countersQuantByCatalog(self, idCounter, catalog, percent, limit, calcWhenLessLimit, alwaysCalcDiscount)

@add_plugin
def countersQuantByGroup(self, idCounter, group, percent, limit, calcWhenLessLimit, alwaysCalcDiscount):
    return counters.countersQuantByGroup(self, idCounter, group, percent, limit, calcWhenLessLimit, alwaysCalcDiscount)

# personaldiscount
@add_plugin
def personalDiscount(self):
    return personaldiscount.personalDiscount(self)

@add_plugin
def countersQuantByAccumulation(self, idCounter, ranges, defaultIndex):
    return counters.countersQuantByAccumulation(self, idCounter, ranges, defaultIndex)

@add_plugin
def countersQuantIndexPrice(self, idCounter, limit, indexPrice, conditionProperties, calcWhenLessLimit, alwaysCalcDiscount):
    return counters.countersQuantIndexPrice(self, idCounter, limit, indexPrice, conditionProperties, calcWhenLessLimit,
                                            alwaysCalcDiscount)

@add_plugin
def proportionalDiscount(self, sum, conditions):
    return proportionaldiscount.proportionalDiscount(self, sum, conditions)

@add_plugin
def age(self):
    return card.age(self)

@add_plugin
def discountCount(self, id, multiplyByQuantity=False):
    return impact.discountCount(self, id, multiplyByQuantity)