'''
Created on 14.02.2011

@author: gsu
'''


from sqlalchemy import Column, Integer, String, Numeric
from legacydiscount.connection.connection import Base, Session
from legacydiscount.discountrate import DiscountRateMixin
session = Session()

class DiscCardAccumulateScheme:
    def __init__(self, code, name):
        self.code = code
        self.name = name 

class DiscCardAccumulate(Base, DiscountRateMixin):
    
    __tablename__ = 'disccardaccumulate'
    
    disccode = Column(Integer, primary_key=True)
    name = Column(String(30))
    rtext = Column(String(30))
    discperc = Column(Numeric(precision=5, scale=1))
    isbegsum = Column(Integer)
    begsum = Column(Numeric(precision=17, scale=2))
    isendsum = Column(Integer)
    endsum = Column(Numeric(precision=17, scale=2))
    isbegrcount = Column(Integer)
    begrcount = Column(Numeric(precision=20,scale=0))
    isendrcount = Column(Integer)
    endrcount = Column(Numeric(precision=20,scale=0))
    discscheme = Column(Integer)
    discschemename = Column(String(30))

    disctype = property(lambda self: 1)
    discmode = property(lambda self: 1)
    discsize = property(lambda self: self.discperc)    
    discval = property(lambda self: self.discperc)
    scheme = property(lambda self: DiscCardAccumulateScheme(self.discscheme, self.discschemename))
    
