# -*- coding: utf-8 -*-
'''
Created on 04.02.2011

@author: gsu
'''

from enum import Enum
from datetime import datetime

class ImpactType(Enum):
    PURE = 'pure'
    ADD = 'add'
    REMOVE = 'remove'
    # addition type
    MODIFY = 'modify'
    BRANCH = 'branch'

class Impact(object):
    """
    Impact
    """
    cards = []
    
    @staticmethod
    def pureImpact(self, campaign=None, discount=None, order=None, absoluteValue=0, impactObject=None, innerObject=None, cards=None):
        self.campaign = campaign
        self.discount = campaign
        self.order = order

    def __init__(self, type=ImpactType.PURE.value, campaign=None, discount=None, order=None, absoluteValue=0, impactObject=None, date=None, innerObject=None, qty=None, cards=None):
        """
        type - type of impact. ImpactType (ImpactType.PURE,ImpactType.ADD,ImpactType.REMOVE)
        campaign - DicountCampaign
        discount - Discount
        absoluteValue - absolute value of discount
        qty - quantity of goods
        """
        self.campaign = campaign
        self.discount = discount
        self.order = order
        self.absoluteValue = absoluteValue
        self.impactObject = impactObject
        self.date = date if date else datetime.now()
        self.innerObject = innerObject
        self.qty = qty
        self.type = type
        self.branchDetails = None
        self.cards = cards if cards else []

    @staticmethod
    def branchImpact(impactObject, branchDetails):
        result = Impact(type=ImpactType.BRANCH.value, impactObject = impactObject)
        result.branchDetails = branchDetails
        return result
        
    def __repr__(self):
        if self.type == ImpactType.BRANCH.value:
            return "<%15s(%s,qty=%4s,branchDetails=%s)>" % ("Impact" + ("%s" % self.type).upper(), self.impactObject, self.qty, self.branchDetails)
        else:
            return "<%15s(%s,qty=%4s,absoluteValue=%s)>" % ("Impact" + ("%s" % self.type).upper(), self.impactObject, self.qty, self.absoluteValue)
