# -*- coding: utf-8 -*-
'''
Created on 08.02.2011

@author: gsu
'''
import logging
from decimal import Decimal
from legacydiscount.discountobject import DiscountObjectMixin

logger = logging.getLogger('su.artix.dm')
class KitEntry(DiscountObjectMixin):
    '''
    Вхождение комплекта в Чек
    '''
    kitgoods = None
    kit = None
    items = []
    times = 0
    
    def __init__(self, kit, items, kg, times):
        self.kit, self.items,self.kitgoods, self.times = kit, items, kg,  times

    def __str__(self):
        return 'Kit Entry (kit: %s, items: %s)' % (self.kit, self.items)

    def __repr__(self):
        return str(self)

    sumb = property(lambda self: sum(item.sumb for item in self.items))
    sumn = property(lambda self: sum(item.sumn for item in self.items))

    def indexPrice(self, index):
        return sum(item.indexPrice(index) for item in self.items)

    bquant = property(lambda self: Decimal(self.times))
    cquant = property(lambda self: Decimal(self.times))

    def calculateDiscounts(self):
        
        discitems = {}       
        for item in self.items:
            for kitdisc in item.kitgoods.kitdiscs:
                discitems.setdefault(kitdisc, []).append(item)
                
        for rate, items in discitems.items():
            vals = rate.appliedToObjects(items)            
            for item in items:
                item.impacts = vals

    def discountImpacts(self):
        
        result = []
        
        for impacts in [ item.impacts for item in self.items if hasattr(item, 'impacts') ]:
            result.extend(impacts)
        
        return result
