'''
Created on 03.03.2011

@author: gsu
'''

import logging
from functools import wraps
from datetime import datetime

logger = logging.getLogger('su.artix.dm')

class Depth:
    depth = 0

def log_before(f):
    @wraps(f)
    def wrapper(*args, **kwds):
        logger.debug("[%d] method '%s' called with args '%s', kwds '%s'" % (Depth.depth, f.__name__, args, kwds))
        Depth.depth += 1
        try:
            return f(*args, **kwds)
        finally:
            Depth.depth -= 1
    return wrapper

def log_after(f):
    @wraps(f)
    def wrapper(*args, **kwds):
        startMark = datetime.now()
        Depth.depth += 1
        try:
            return f(*args, **kwds)
        finally:
            Depth.depth -= 1
            endMark = datetime.now()
            logger.debug("[%d] method '%s' finished. It took %s" % (Depth.depth, f.__name__, (endMark - startMark)))
    return wrapper

def log_wrap(f):
    @wraps(f)
    def wrapper(*args, **kwds):
        startMark = datetime.now()
        logger.debug("[%d] method '%s' called with args '%s', kwds '%s'" % (Depth.depth, f.__name__, args, kwds))
        Depth.depth += 1
        try:
            return f(*args, **kwds)
        finally:
            Depth.depth -= 1
            endMark = datetime.now()
            logger.debug("[%d] method '%s' finished. It took %s" % (Depth.depth, f.__name__, (endMark - startMark)))
    return wrapper
