# -*- coding: utf-8 -*-
'''
Created on 03.02.2011

@author: gsu
'''

from sqlalchemy import Column, Integer, String, Numeric
from legacydiscount.connection.connection import Base, Session

session = Session()

class Sprices(Base):
    '''
    Ценовая схема
    '''

    __tablename__ = 'sprices'

    code = Column(Integer, primary_key=True)
    name = Column(String(32))
    type = Column(Integer)                      # type = 1 => применяется только по карте!
    inp_mode = Column(Integer)
    force_mode = Column(Integer)
    ext_mode = Column(Integer)
    cmp_mode = Column(Integer)
    price = Column(Numeric(precision=13, scale=2))
    sindex = Column(Integer)
    disc_perc = Column(Numeric(precision=5, scale=2))
    disc_abs = Column(Numeric(precision=13, scale=2))
    ext_proc = Column(String(80))

    @classmethod
    def select(cls, shemecode):
        return session.query(cls).filter_by(code=shemecode).all()

    def __str__(self):
        return u'Sprices (code: %d, name: "%s")' % (self.code, self.name)

    def __repr__(self):
        return str(self)

    def __eq__(self, other):
        return self.code == other.code

    def __hash__(self):
        return hash(self.code)
