# -*- coding: utf-8 -*-

from sqlalchemy import Column, Integer, String, Numeric
from simplediscount.connection.connection import Base, Session

session = Session()

class DiscountConfig(Base):
    '''
    Настройки дисконта 
    '''

    __tablename__ = 'cashconfig'

    name = Column(String(100), primary_key=True)
    value = Column(String(100))

    @classmethod
    def select(cls, optionname):
        return session.query(cls).filter_by(name=optionname).all()

    def __str__(self):
        return u'Discount config (name: %s, value: "%s")' % (self.name, self.value)

    def __repr__(self):
        return str(self)

    def __eq__(self, other):
        return self.name == other.name and self.value == other.value

    def __hash__(self):
        return hash(self.name)