# -*- coding: utf-8 -*-
'''
Created on 09.03.2011

@author: gsu
'''

from sqlalchemy import Column, Integer, String, Numeric
from connection.connection import Base, Session
from discountrate import DiscountRateMixin
from bunch import Bunch

session = Session()

class FixedDiscount(Base, DiscountRateMixin):
    '''
    Фиксированная скидка Штрих-М
    '''

    __tablename__ = 'discountsfixed'

    disccode = Column(Integer, primary_key=True)
    name = Column(String(25))
    disctype = Column(Integer)
    discmode = Column(Integer)
    discsize = Column(Numeric(precision=15, scale=2))
    rtext = Column(String(30))
    cardpref = Column(String(24))
    receiptmode = Column(Integer)
    positionmode = Column(Integer)
    cardonly = Column(Integer)
    cardsum_beg = Column(Numeric(precision=18, scale=2))
    cardsum_end = Column(Numeric(precision=18, scale=2))

    discval = property(lambda self: self.discsize)
    scheme = Bunch(code=0, name=u'Фиксированная скидка')

    def __str__(self):
        return u'Fixed Discount (code: %d, name: "%s", value: %.2f)' % (self.disccode, self.name, self.discsize)

    def __repr__(self):
        return str(self)

    def __eq__(self, other):
        return self.disccode == other.disccode

    def __hash__(self):
        return hash(self.disccode)
