# -*- coding: utf-8 -*-

from simplediscount.discountmanager import DiscountManager, DiscountCollection, Discount, DiscountMode
from simplediscount.checktotals import CheckTotals, DiscountObjectForCheck
import jsonpickle
import logging.config
from simplediscount.log_decorator import log_after

try:
    logging.config.fileConfig('/linuxcash/cash/discountsystems/log.ini')
except:
    logging.basicConfig()

logger = logging.getLogger('su.artix.dm')


def refreshSystems():
    pass


@log_after
def encodeResult(d, b):
    return jsonpickle.encode([[q.toDict() for q in d], b])


@log_after
def calculateImpact(check):
    totals = CheckTotals(check)
    dm = DiscountManager(totals)
    d = DiscountCollection(dm.config)
    d.extend(dm.discount(check))
    d.extend(dm.discountOnCheck(check))
    dm.applyDiscRelation(d)
    return {}, d
